create or replace PROCEDURE IMPEXP_APRESENT(
P_IDIMPEXP   IN CHAR, /* I: Importar    - E: Exportar */
P_IDTIPOPER  IN CHAR, /* 0: Acrescentar - 1: Sobrepor */
P_CDCIA      IN COMPANHIA.CDCIA%TYPE,
P_CDMANCIA   IN MANUALCIA.CDMANCIA%TYPE,
P_CDSERVICO  IN SERVMANUAL.CDSERVICO%TYPE,
P_CDSUBGRU   IN VARCHAR,
P_CDMANAP    IN MANUALCIAAP.CDMANAP%TYPE,
P_CDFILIAL   IN FILIAL.CDFILIAL%TYPE,
P_CDCLASSE   IN SUBGRUSEMA.CDCLASSE%TYPE,
P_CDCICLO    IN SUBGRUSEMA.CDCICLO%TYPE,
P_CDOPERADOR IN OPERADOR.CDOPERADOR%TYPE,
P_DTAPRESUMA IN SUBGRUSEMA.DTAPRESUMA%TYPE
)
AS
V_CDESPEPROD_SER COMPPROD.CDESPEPROD%TYPE;
V_CDESPEPROD_SUB COMPPROD.CDESPEPROD%TYPE;
V_CDTIPOCOMP     COMPPROD.CDTIPOCOMP%TYPE;
V_CDPRODUTO      PRODUTO.CDPRODUTO%TYPE;

BEGIN
   IF P_IDIMPEXP = 'E' THEN
      IF P_IDTIPOPER = '1' THEN
         FOR C_COMP IN (SELECT CDPRODUTO,CDESPEPROD,CDPRODUTOAUX,CDESPPRODAUX
                        FROM COMPPROD CP
                        WHERE (EXISTS (SELECT CDPRODUTO
                                       FROM ESPEPROD
                                       WHERE (CDFILIAL      = P_CDFILIAL ) AND
                                             (CDCIA         = P_CDCIA    ) AND
                                             (CDMANCIA      = P_CDMANCIA ) AND
                                             (CDPRODUTO     = P_CDSERVICO) AND
                                             (IDTPMANUAL    = 'M'        ) AND
                                             (CP.CDPRODUTO  = CDPRODUTO  ) AND
                                             (CP.CDESPEPROD = CDESPEPROD )))) LOOP
             DELETE FROM COMPPROD /* produtos e receitas */
             WHERE (CDPRODUTO  = C_COMP.CDPRODUTOAUX) AND
                   (CDESPEPROD = C_COMP.CDESPPRODAUX);
             DELETE FROM COMPPROD /* sub-grupos */
             WHERE (CDPRODUTO  = C_COMP.CDPRODUTO ) AND
                   (CDESPEPROD = C_COMP.CDESPEPROD);
             DELETE FROM ESPEPROD /* sub-grupos */
             WHERE (CDPRODUTO  = C_COMP.CDPRODUTOAUX) AND
                   (CDESPEPROD = C_COMP.CDESPPRODAUX);
         END LOOP;
      END IF;

      SELECT MIN(CDESPEPROD)
      INTO V_CDESPEPROD_SER
      FROM ESPEPROD
      WHERE (CDFILIAL   = P_CDFILIAL ) AND
            (CDCIA      = P_CDCIA    ) AND
            (CDMANCIA   = P_CDMANCIA ) AND
            (CDPRODUTO  = P_CDSERVICO) AND
            (IDTPMANUAL = 'M'        );

      BEGIN
         SELECT CDTIPOCOMP
           INTO V_CDTIPOCOMP
           FROM PARAMCOMIS
          WHERE (CDFILIAL = P_CDFILIAL);
       EXCEPTION
          WHEN NO_DATA_FOUND THEN
             V_CDTIPOCOMP := NULL;
       END;

      FOR C_ESP IN (SELECT CDPRODUTO,CDESPEPROD
                    FROM ESPEPROD EP
                    WHERE (CDFILIAL   = P_CDFILIAL) AND
                          (CDCIA      = P_CDCIA   ) AND
                          (CDMANCIA   = P_CDMANAP ) AND
                          (IDTPMANUAL = 'A'       ) AND
                          ((INSTR(P_CDSUBGRU,'_'||CDPRODUTO||'_')>0) OR (P_CDSUBGRU = 'T'))) LOOP

         SELECT MIN(CDESPEPROD)
         INTO V_CDESPEPROD_SUB
         FROM COMPPROD
         WHERE (CDPRODUTO    = P_CDSERVICO     ) AND
               (CDESPEPROD   = V_CDESPEPROD_SER) AND
               (CDPRODINSUMO = C_ESP.CDPRODUTO );

         IF V_CDESPEPROD_SUB IS NULL THEN
            SELECT LPAD(TO_CHAR(NVL(TO_NUMBER(MAX(CDESPEPROD)),0)+1),10,'0')
            INTO V_CDESPEPROD_SUB
            FROM ESPEPROD
            WHERE (CDPRODUTO = C_ESP.CDPRODUTO);

            SELECT MAX(CDPRODUTO)
            INTO V_CDPRODUTO
            FROM ESPEPROD
            WHERE CDPRODUTO  = C_ESP.CDPRODUTO AND
                  CDESPEPROD = V_CDESPEPROD_SUB;


            IF V_CDPRODUTO IS NULL THEN
               insert into ESPEPROD
               (CDPRODUTO, CDESPEPROD, NMESPEPROD, DTVALESPEPRO, DTINCESPEPRO,
                CDFILIAL, CDOPERADOR, CDCIA, CDMANCIA, IDCOMPPADRAO, IDTPMANUAL)
               values
               (C_ESP.CDPRODUTO, V_CDESPEPROD_SUB, 'Especificao-'||V_CDESPEPROD_SUB, P_DTAPRESUMA, P_DTAPRESUMA,
                P_CDFILIAL, P_CDOPERADOR, P_CDCIA, P_CDMANCIA, 'P', 'M');
            END IF;

            INSERT INTO COMPPROD /* sub-grupos */
            (CDPRODUTO,CDESPEPROD,CDTIPOCOMP,CDPRODINSUMO,IDUTAPROVREQ,
             QTINSUMO,CDPRODUTOAUX,CDESPPRODAUX,DSLOADCOMP,VRLOADCOMP)
            VALUES
            (P_CDSERVICO,V_CDESPEPROD_SER,V_CDTIPOCOMP,C_ESP.CDPRODUTO,'N',
             1,C_ESP.CDPRODUTO,V_CDESPEPROD_SUB,'100',100);
         END IF;

         INSERT INTO COMPPROD /* produtos e receitas */
         (CDPRODUTO,CDESPEPROD,CDTIPOCOMP,CDPRODINSUMO,IDUTAPROVREQ,
          QTINSUMO,CDTIPOINSU,SGUNIDADE,IDSEMIACCOMP,IDUTILOTEPR,
          CDPRODUTOAUX,CDESPPRODAUX,NRORDCOMP,TXCOMITCOMP,IDIMPCOMPDEL,
          VRLOADCOMP,DSLOADCOMP,QTBRUTINSPRO,VRPRENDINSPR)
         SELECT CDPRODUTO,V_CDESPEPROD_SUB,V_CDTIPOCOMP,CDPRODINSUMO,IDUTAPROVREQ,
                QTINSUMO,CDTIPOINSU,SGUNIDADE,IDSEMIACCOMP,IDUTILOTEPR,
                P_CDSERVICO,V_CDESPEPROD_SER,NRORDCOMP,TXCOMITCOMP,IDIMPCOMPDEL,
                VRLOADCOMP,DSLOADCOMP,QTBRUTINSPRO,VRPRENDINSPR
         FROM COMPPROD CP
         WHERE (CDPRODUTO  = C_ESP.CDPRODUTO ) AND
               (CDESPEPROD = C_ESP.CDESPEPROD) AND
               (NOT EXISTS (SELECT CDPRODUTO
                            FROM COMPPROD
                            WHERE (CDPRODUTO    = CP.CDPRODUTO    ) AND
                                  /*(CDESPEPROD   = V_CDESPEPROD_SUB) AND*/
                                  (CDPRODINSUMO = CP.CDPRODINSUMO ) AND
                                  (CDPRODUTOAUX = P_CDSERVICO     ) AND
                                  (CDESPPRODAUX = V_CDESPEPROD_SER)));
      END LOOP;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('IMPEXP_APRESENT','4.07.256'); END;
/

